﻿Imports System
Imports System.Runtime.InteropServices
Imports Microsoft.VisualBasic
Imports System.Threading

Public Class CMediaRs232
    Implements IDisposable
    Private mhRS As Int32 = -1		 '// Handle to Com Port			
    Private miPort As Integer = 1		 '//  Default is COM1	
    Private miTimeout As Int32 = 70		 '// Timeout in ms
    Private miBaudRate As Int32 = 9600
    Private meParity As DataParity = 0
    Private meStopBit As DataStopBit = 0
    Private miDataBit As Int32 = 8
    Private miBufferSize As Int32 = 512		 '// Buffers size default to 512 bytes
    Private mabtRxBuf As Byte()		 '//  Receive buffer	
    Private mobjThreadListen As Thread
    Private mobjThreadWrite As Thread
    Private mbytWriteBuffer() As Byte
    Public Event DataReceived(ByVal sender As CMediaRs232, ByVal Data() As Byte)
    Public Event DataSent(ByVal sender As CMediaRs232)
    Private blnIsSending As Boolean
    #Region "Enums"
    Public Enum DataParity
            Parity_None = 0
            Pariti_Odd
            Parity_Even
            Parity_Mark
    End Enum
    
    Public Enum DataStopBit
            StopBit_1 = 1
            StopBit_2
    End Enum
    Private Enum PurgeBuffers
            RXAbort = &H2
            RXClear = &H8
            TxAbort = &H1
            TxClear = &H4
    End Enum
    
    Private Enum Lines
            SetXOff = 1
            SetXOn = 2
            SetRts = 3
            ClearRts = 4
            SetDtr = 5
            ClearDtr = 6
            ResetDev = 7
            SetBreak = 8
            ClearBreak = 9
    End Enum
    #End Region
    #Region "Structures"
    <StructLayout(LayoutKind.Sequential, Pack:=1)> Private Structure DCB
            Private DCBlength As Int32
            Private BaudRate As Int32
            Private Bits1 As Int32
            Private wReserved As Int16
            Private XonLim As Int16
            Private XoffLim As Int16
            Private ByteSize As Byte
            Private Parity As Byte
            Private StopBits As Byte
            Private XonChar As Byte
            Private XoffChar As Byte
            Private ErrorChar As Byte
            Private EofChar As Byte
            Private EvtChar As Byte
            Private wReserved2 As Int16
    End Structure
    <StructLayout(LayoutKind.Sequential, Pack:=1)> Private Structure COMMTIMEOUTS
            Public ReadIntervalTimeout As Int32
            Public ReadTotalTimeoutMultiplier As Int32
            Public ReadTotalTimeoutConstant As Int32
            Public WriteTotalTimeoutMultiplier As Int32
            Public WriteTotalTimeoutConstant As Int32
    End Structure
    
    <StructLayout(LayoutKind.Sequential, Pack:=1)> Private Structure COMMCONFIG
            Private dwSize As Int32
            Private wVersion As Int16
            Private wReserved As Int16
            Private dcbx As DCB
            Private dwProviderSubType As Int32
            Private dwProviderOffset As Int32
            Private dwProviderSize As Int32
            Private wcProviderData As Byte
    End Structure
    
    <StructLayout(LayoutKind.Sequential, Pack:=1)> Private Structure OVERLAPPED
        Public Internal As Int32
        Public InternalHigh As Int32
        Public offset As Int32
        Public OffsetHigh As Int32
        Public hEvent As Int32
    End Structure
    #End Region
    #Region "Constants"
    Private Const PURGE_RXABORT As Integer = &H2
    Private Const PURGE_RXCLEAR As Integer = &H8
    Private Const PURGE_TXABORT As Integer = &H1
    Private Const PURGE_TXCLEAR As Integer = &H4
    Private Const GENERIC_READ As Integer = &H80000000
    Private Const GENERIC_WRITE As Integer = &H40000000
    Private Const OPEN_EXISTING As Integer = 3
    Private Const INVALID_HANDLE_VALUE As Integer = -1
    Private Const IO_BUFFER_SIZE As Integer = 1024
    
    #End Region
    
    #Region "Win32API"
    'KL 2/4/02
    Const FILE_FLAG_OVERLAPPED As Integer = &H40000000
    Const INFINITE = -1&
    Const ERROR_IO_PENDING = 997
    Const WAIT_OBJECT_0 = 0
    Const EV_RXCHAR As Integer = &H1
    Const WAIT_TIMEOUT = &H102&
    
    Const MS_CTS_ON As Int32 = &H10
    Const MS_DSR_ON As Int32 = &H20
    Const MS_RING_ON As Int32 = &H40
    Const MS_RLSD_ON As Int32 = &H80
    
    <DllImport("kernel32.dll")> Private Shared Function GetCommModemStatus(ByVal hCommDev As Int32, ByRef lpModemStat As Int32) As Boolean
    End Function
    <DllImport("kernel32.dll")> Private Shared Function SetCommState(ByVal hCommDev As Int32, ByRef lpDCB As DCB) As Int32
    End Function
    <DllImport("kernel32.dll")> Private Shared Function GetCommState(ByVal hCommDev As Int32, ByRef lpDCB As DCB) As Int32
    End Function
    <DllImport("kernel32.dll", CharSet:=CharSet.Auto)> Private Shared Function BuildCommDCB(ByVal lpDef As String, ByRef lpDCB As DCB) As Int32
    End Function
    <DllImport("kernel32.dll")> Private Shared Function SetupComm(ByVal hFile As Int32, ByVal dwInQueue As Int32, ByVal dwOutQueue As Int32) As Int32
    End Function
    <DllImport("kernel32.dll")> Private Shared Function SetCommTimeouts(ByVal hFile As Int32, ByRef lpCommTimeouts As COMMTIMEOUTS) As Int32
    End Function
    <DllImport("kernel32.dll")> Private Shared Function GetCommTimeouts(ByVal hFile As Int32, ByRef lpCommTimeouts As COMMTIMEOUTS) As Int32
    End Function
    <DllImport("kernel32.dll")> Private Shared Function ClearCommError(ByVal hFile As Int32, ByVal lpErrors As Int32, ByVal l As Int32) As Int32
    End Function
    <DllImport("kernel32.dll")> Private Shared Function PurgeComm(ByVal hFile As Int32, ByVal dwFlags As Int32) As Int32
    End Function
    <DllImport("kernel32.dll")> Private Shared Function EscapeCommFunction(ByVal hFile As Integer, ByVal ifunc As Long) As Boolean
    End Function
    <DllImport("kernel32.dll")> Private Shared Function WaitCommEvent(ByVal hFile As Integer, ByRef Mask As Integer, ByRef lpOverlap As OVERLAPPED) As Int32
    End Function
    <DllImport("kernel32.dll")> Private Shared Function WriteFile(ByVal hFile As Integer, ByVal Buffer As Byte(), ByVal nNumberOfBytesToWrite As Integer, ByRef lpNumberOfBytesWritten As Integer, ByRef lpOverlapped As OVERLAPPED) As Integer
    End Function
    <DllImport("kernel32.dll")> Private Shared Function ReadFile(ByVal hFile As Integer, ByVal Buffer As Byte(), ByVal nNumberOfBytesToRead As Integer, ByRef lpNumberOfBytesRead As Integer, ByRef lpOverlapped As OVERLAPPED) As Integer
    End Function
    <DllImport("kernel32.dll")> Private Shared Function CreateFile(<MarshalAs(UnmanagedType.LPStr)> ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Integer, ByVal dwShareMode As Integer, _
    ByVal lpSecurityAttributes As Integer, ByVal dwCreationDisposition As Integer, _
    ByVal dwFlagsAndAttributes As Integer, ByVal hTemplateFile As Integer) As Integer
    End Function
    <DllImport("kernel32.dll")> Private Shared Function CloseHandle(ByVal hObject As Integer) As Integer
    End Function
    <DllImport("kernel32.dll")> Private Shared Function FormatMessage(ByVal dwFlags As Integer, _
    ByVal lpSource As Integer, ByVal dwMessageId As Integer, _
    ByVal dwLanguageId As Integer, _
    <MarshalAs(UnmanagedType.LPStr)> ByVal lpBuffer As String, _
    ByVal nSize As Integer, ByVal Arguments As Integer) As Integer
    End Function
    
    <DllImport("kernel32.dll")> Private Shared Function SetCommMask(ByVal hFile As Int32, ByVal lpEvtMask As Int32) As Int32
    End Function
    Private Declare Function CreateEvent Lib "kernel32" Alias "CreateEventA" (ByVal lpEventAttributes As Int32, ByVal bManualReset As Int32, ByVal bInitialState As Int32, ByVal lpName As String) As Int32
    Private Declare Function GetLastError Lib "kernel32" Alias "GetLastError" () As Int32
    Private Declare Function WaitForSingleObject Lib "kernel32" Alias "WaitForSingleObject" (ByVal hHandle As Int32, ByVal dwMilliseconds As Int32) As Int32
    Private Declare Function GetOverlappedResult Lib "kernel32" Alias "GetOverlappedResult" (ByVal hFile As Int32, ByRef lpOverlapped As OVERLAPPED, ByRef lpNumberOfBytesTransferred As Int32, ByVal bWait As Int32) As Int32
    
    #End Region
    
    Public Property Port() As Integer
            Get
                    Return miPort
            End Get
            Set(ByVal Value As Integer)
                    miPort = Value
            End Set
    End Property
    Public Overridable Property Timeout() As Integer
            Get
                    Return miTimeout
            End Get
            Set(ByVal Value As Integer)
                    miTimeout = CInt(IIf(Value = 0, 500, Value))
                    pSetTimeout()
            End Set
    End Property
    Public Property Parity() As DataParity
            Get
                    Return meParity
            End Get
            Set(ByVal Value As DataParity)
                    meParity = Value
            End Set
    End Property
    Public Property StopBit() As DataStopBit
            Get
                    Return meStopBit
            End Get
            Set(ByVal Value As DataStopBit)
                    meStopBit = Value
            End Set
    End Property
    Public Property BaudRate() As Integer
            Get
                    Return miBaudRate
            End Get
            Set(ByVal Value As Integer)
                    miBaudRate = Value
            End Set
    End Property
    Public Property DataBit() As Integer
            Get
                    Return miDataBit
            End Get
            Set(ByVal Value As Integer)
                    miDataBit = Value
            End Set
    End Property
    Public Property BufferSize() As Integer
            Get
                    Return miBufferSize
            End Get
            Set(ByVal Value As Integer)
                    miBufferSize = Value
            End Set
    End Property
    Public Sub Open()
            Dim uDcb As DCB, iRc As Int32
            If miPort > 0 Then
                    Try
                            mhRS = CreateFile("COM" & miPort.ToString, _
                            GENERIC_READ Or GENERIC_WRITE, 0, 0, _
                            OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0)
                            If mhRS <> -1 Then
                                    Dim lpErrCode As Int32
                                    iRc = ClearCommError(mhRS, lpErrCode, 0&)
                                    iRc = PurgeComm(mhRS, PurgeBuffers.RXClear Or PurgeBuffers.TxClear)
                                    iRc = GetCommState(mhRS, uDcb)
                                    Dim sParity As String = "noem"
                                    sParity = sParity.Substring(meParity, 1)
                                    Dim sDCBState As String = miBaudRate.ToString & "," & sParity & "," & _
                                     miDataBit.ToString & "," & CInt(meStopBit).ToString
                                    iRc = BuildCommDCB(sDCBState, uDcb)
                                    iRc = SetCommState(mhRS, uDcb)
                                    iRc = SetupComm(mhRS, miBufferSize, miBufferSize)
                                    pSetTimeout()
                                    StartListenerThread()
                            Else
                                    Throw New CIOChannelException("Unable to open COM" & miPort.ToString)
                            End If
                    Catch Ex As Exception
                            Throw New CIOChannelException(Ex.Message, Ex)
                    End Try
            Else
                    Throw New ApplicationException("COM Port not defined,use Port property to set it before invoking InitPort")
            End If
    End Sub
    Public Sub Close()
            If mhRS <> -1 Then
                    CloseHandle(mhRS)
                    mhRS = -1
            End If
    End Sub
    ReadOnly Property IsOpen() As Boolean
            Get
                    Return CBool(Not mhRS = -1)
            End Get
    End Property
    
    ReadOnly Property IsSending() As Boolean
    Get
        Return blnIsSending
    End Get
    End Property
    'Private Sub DoWrite(ByVal Buffer As Byte())
    Private Sub DoWrite()
            Dim iBytesWritten As Integer, iRc As Integer
            If mhRS = -1 Then
                    Throw New ApplicationException("Please initialize and open port before using this method")
            Else
                    Try
                            Dim osWrite As Overlapped
                            Dim intResult As Int32
                            blnIsSending = True
                            osWrite.hEvent = CreateEvent(Nothing, 0, 0, Nothing)
                            iRc = WriteFile(mhRS, mbytWriteBuffer, mbytWriteBuffer.Length, iBytesWritten, osWrite)
                            Dim LastError As Int32
                            If iRc = 0 Then
                                LastError = GetLastError
                                If LastError = ERROR_IO_PENDING Then
                                    Dim dwRes As Int32
                                    'KL - Is it okay to wait inifinitely?
                                    dwRes = WaitForSingleObject(osWrite.hEvent, INFINITE)
                                    If dwRes = WAIT_OBJECT_0 Then
                                        intResult = GetOverlappedResult(mhRS, osWrite, iBytesWritten, 0)
                                        If intResult = 0 Then
                                            blnIsSending = False
                                            Throw New ApplicationException("GetOverlappedResult failed")
                                            Exit Sub
                                        Else
                                            RaiseEvent DataSent(Me)
                                        End If
                                    End If
                                Else
                                    blnIsSending = False
                                    Throw New ApplicationException("Write Error - Bytes Written " & iBytesWritten.ToString & " of " & mbytWriteBuffer.Length.ToString)
                                End If
                            Else
                                RaiseEvent DataSent(Me)
                            End If
                            blnIsSending = False
                            'If iRc = 0 Then MsgBox(GetLastError)
                            'If iRc = 0 Then
                            '        Throw New ApplicationException("Write Error - Bytes Written " & iBytesWritten.ToString & " of " & Buffer.Length.ToString)
                            'End If
                    Catch Ex As Exception
                            Throw
                    End Try
            End If
    End Sub
    Private Function Read(ByVal Bytes2Read As Integer) As Integer
            Dim iReadChars, iRc As Integer
            Dim intResult As Integer
            Dim intLastError As Integer
            If Bytes2Read = 0 Then Bytes2Read = miBufferSize
            If mhRS = -1 Then
                    Throw New ApplicationException("Please initialize and open port before using this method")
            Else
                    '// Get bytes from port
                    Try
                            ReDim mabtRxBuf(Bytes2Read - 1)
                            Dim blnWaitingOnRead As Boolean
                            Dim OL As Overlapped
                            OL.hEvent = CreateEvent(Nothing, 0, 0, Nothing)
                            If OL.hEvent = 0 Then
                                Throw New ApplicationException("CMediaRS232:Read - CreateEvent failed")
                                Exit Function
                            End If
    
                            If Not blnWaitingOnRead Then
                                intResult = ReadFile(mhRS, mabtRxBuf, Bytes2Read, iReadChars, OL)
                                If intResult = 0 Then
                                    intLastError = GetLastError
                                    If intLastError = ERROR_IO_PENDING Then
                                        blnWaitingOnRead = True
                                        'Now what?
                                    Else
                                        'Error
                                        'MsgBox("Error in ReadFile")
                                        Throw New ApplicationException("CMediaRS232:Read - ReadFile failed with error " & intLastError)
                                        'MsgBox("Only read " & iReadChars)
                                        'RaiseEvent DataReceived(Me, mabtRxBuf)
                                        Exit Function
                                        'tmp statement:
                                        'blnWaitingOnRead = True
                                    End If
                                Else
                                    'Successful read
                                    RaiseEvent DataReceived(Me, mabtRxBuf)
                                End If
                            End If
    
                            If blnWaitingOnRead Then
                                'intResult = WaitForSingleObject(OL.hEvent, miTimeout)
                                intResult = WaitForSingleObject(OL.hEvent, INFINITE)
                                Select Case intResult
                                    Case WAIT_OBJECT_0
                                        '(!GetOverlappedResult(hComm, &osReader, &dwRead, FALSE))
                                        intResult = GetOverlappedResult(mhRS, OL, iReadChars, 0)
                                        If intResult = 0 Then
                                            'MsgBox("Error in Read:GetOverlappedResult")
                                            Throw New ApplicationException("CMediaRS232:Read - GetOverlappedResult failed")
                                            Exit Function
                                        Else
                                            'Successful read - throw out if there were actually no bytes
                                            If iReadChars > 0 Then
                                                ReDim Preserve mabtRxBuf(iReadChars - 1)
                                                RaiseEvent DataReceived(Me, mabtRxBuf)
                                            End If
                                        End If
                                        blnWaitingOnRead = False
                                    Case WAIT_TIMEOUT
                                        'MsgBox("Wait timeout")
                                        Throw New ApplicationException("CMediaRS232:Read - Wait Timeout occurred")
                                    Case Else
                                        'MsgBox("Error in Read:WaitForSingleObject")
                                        Throw New ApplicationException("CMediaRS232:Read - WaitForSingleObject failed and returned " & intResult)
                                        Exit Function
                                End Select
                            End If
    
                    Catch Ex As Exception
                            '// Others generic erroes
                            Throw New ApplicationException("Read Error: " & Ex.Message, Ex)
                    End Try
            End If
    End Function
    
    Overridable ReadOnly Property InputStream() As Byte()
            Get
                    Return mabtRxBuf
            End Get
    End Property
    Public Sub ClearInputBuffer()
            If Not mhRS = -1 Then
                    PurgeComm(mhRS, PURGE_RXCLEAR)
            End If
    End Sub
    Public WriteOnly Property Rts() As Boolean
            Set(ByVal Value As Boolean)
                    If Not mhRS = -1 Then
                            If Value Then
                                    EscapeCommFunction(mhRS, Lines.SetRts)
                            Else
                                    EscapeCommFunction(mhRS, Lines.ClearRts)
                            End If
                    End If
            End Set
    End Property
    Public WriteOnly Property Break() As Boolean
            Set(ByVal Value As Boolean)
                    If Not mhRS = -1 Then
                            If Value Then
                                    EscapeCommFunction(mhRS, Lines.SetBreak)
                            Else
                                    EscapeCommFunction(mhRS, Lines.ClearBreak)
                            End If
                    End If
            End Set
    End Property

    Public WriteOnly Property Dtr() As Boolean
            Set(ByVal Value As Boolean)
                    If Not mhRS = -1 Then
                            If Value Then
                                    EscapeCommFunction(mhRS, Lines.SetDtr)
                            Else
                                    EscapeCommFunction(mhRS, Lines.ClearDtr)
                            End If
                    End If
            End Set
    End Property

    Public ReadOnly Property Cts() As Boolean
        Get
            If Not mhRS = -1 Then
                Dim inputLine As Int32
                If GetCommModemStatus (mhRS, inputLine) Then
                    Return inputLine And MS_CTS_ON
                Else
                    Return False
                End If
            Else
                Return False
            End If
        End Get
    End Property

    Public ReadOnly Property Dsr() As Boolean
        Get
            If Not mhRS = -1 Then
                Dim inputLine As Int32
                If GetCommModemStatus (mhRS, inputLine) Then
                    Return inputLine And MS_DSR_ON
                Else
                    Return False
                End If
            Else
                Return False
            End If
        End Get
    End Property

    Public ReadOnly Property Dcd() As Boolean
        Get
            If Not mhRS = -1 Then
                Dim inputLine As Int32
                If GetCommModemStatus (mhRS, inputLine) Then
                    Return inputLine And MS_RLSD_ON
                Else
                    Return False
                End If
            Else
                Return False
            End If
        End Get
    End Property

    Public ReadOnly Property Ri() As Boolean
        Get
            If Not mhRS = -1 Then
                Dim inputLine As Int32
                If GetCommModemStatus (mhRS, inputLine) Then
                    Return inputLine And MS_RING_ON
                Else
                    Return False
                End If
            Else
                Return False
            End If
        End Get
    End Property

    Public Sub DoListen()
        Dim intResult As Int32
        Dim OL As Overlapped, intEvent As Int32
        'Dim intMask As Int16
        Dim intMask As Int32
        Dim blnWaitingOnStat As Boolean
        Dim intLastError As Int32
        Const STATUS_CHECK_TIMEOUT As Int32 = 500
        intResult = SetCommMask(mhRS, EV_RXCHAR)
        OL.hEvent = CreateEvent(Nothing, 0, 0, Nothing)
        'This thread uses an infinite loop
        Do While True
            If Not blnWaitingOnStat Then
                intResult = WaitCommEvent(mhRS, intMask, OL)
                If intResult = 0 Then
                    intLastError = GetLastError
                    If intLastError = ERROR_IO_PENDING Then
                        'KL 2/5/02 - not sure if this is the right variable
                        'In MSDN article it had a different name than the others
                        blnWaitingOnStat = True
                    Else
                        'Error condition.  Should leave function
                        'MsgBox("Error " & intLastError & " occurred in WaitCommEvent")
                        Throw New ApplicationException("CMediaRS232:DoListen - WaitCommEvent failed with error " & intLastError)
                        Exit Sub
                    End If
                Else
                    'Status has changed! - Raise Event here
                    'MsgBox("Status Change!")
                    'KL 2/5/02 - changing mask seems to avoid second triggering of event
                    'intResult = SetCommMask(mhRS, 0)
                    'intResult = SetCommMask(mhRS, EV_RXCHAR)
                    Read(0)
                End If
            End If
    
            If blnWaitingOnStat Then
                'intResult = WaitForSingleObject(OL.hEvent, STATUS_CHECK_TIMEOUT)
                'KL 2/4/02 - Since this is just a background thread, why not just use infinite to block it?
                intResult = WaitForSingleObject(OL.hEvent, INFINITE)
                Select Case intResult
                    Case WAIT_OBJECT_0
                        'if (!GetOverlappedResult(hComm, &osStatus, &dwOvRes, FALSE))
                        Dim intBytes As Int32
                        intResult = GetOverlappedResult(mhRS, OL, intBytes, 0)
                        If intResult = 0 Then
                                'error
                                'MsgBox("Error in GetOverlappedResult")
                                Exit Sub
                        Else
                                'Got data - raise event
                                'MsgBox("Got status change")
                                'KL 2/5/02 - changing mask seems to avoid second triggering of event
                                'intResult = SetCommMask(mhRS, 0)
                                'intResult = SetCommMask(mhRS, EV_RXCHAR)
                                Read(0)
                        End If
                        blnWaitingOnStat = False
    
                    Case WAIT_TIMEOUT
                        'do nothing 
                    Case Else
                        'Error
                        'MsgBox("Error in WaitForSingleObject")
                        Throw New ApplicationException("CMediaRS232:DoListen - WaitForSingleObject failed and returned " & intResult)
                End Select
            End If
        Loop
    
    End Sub
    
    Private Sub StartListenerThread()
        'KL 1/31/02
        mobjThreadListen = New Thread(AddressOf DoListen)
        mobjThreadListen.Start()
    End Sub
    
    Public Sub Write(ByVal Buffer As Byte())
        If blnIsSending Then
            Throw New ApplicationException("CMediaRS232:Write - Cannot send a new message until previous send is complete")
        Else
            mbytWriteBuffer = Buffer
            mobjThreadWrite = New Thread(AddressOf DoWrite)
            mobjThreadWrite.Start()
        End If
    End Sub
    
    Public Sub Dispose() Implements IDisposable.Dispose
        'KL 2/5/02
            If mhRS <> -1 Then
                CloseHandle(mhRS)
                mhRS = -1
            End If
    End Sub
    #Region "Private Routines"
    Private Sub pSetTimeout()
            Dim uCtm As COMMTIMEOUTS
            '// Set ComTimeout
            If mhRS = -1 Then
                    Exit Sub
            Else
                    '// Changes setup on the fly
                    With uCtm
                            .ReadIntervalTimeout = 0
                            .ReadTotalTimeoutMultiplier = 0
                            .ReadTotalTimeoutConstant = miTimeout
                            .WriteTotalTimeoutMultiplier = 10
                            .WriteTotalTimeoutConstant = 100
                    End With
                    SetCommTimeouts(mhRS, uCtm)
            End If
    End Sub
    #End Region
    End Class

#Region "CIOChannelException"
Public Class CIOChannelException : Inherits ApplicationException
		Sub New(ByVal Message As String)
				MyBase.New(Message)
		End Sub
		Sub New(ByVal Message As String, ByVal InnerException As Exception)
				MyBase.New(Message, InnerException)
		End Sub
End Class
#End Region
